#!/usr/bin/env python
# -*- coding: utf-8 -*-

# ---------------------------------------------------------------------
# CGI Frontend for whohas
# ---------------------------------------------------------------------
# Copyright (c) 2008-2009 SCS TeleMedia AG <scs@telemedia.ch>
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
# THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# --------------------------------------------------------------------------
#  $Id: whohas.cgi,v 1.4 2009-02-24 17:32:18 obiwan Exp $
# --------------------------------------------------------------------------
# ###########################################################
# TODO:
# NOTES:
# CHANGES: fixed columns widths for 0.23
# ###########################################################

"""
__author__  = "$Author: obiwan $ (cschnee@telemedia.ch)"
__appname__ = "whohas.cgi"
__version__ = "$Revision: 1.4 $"
__date__    = "$Date: 2009-02-24 17:32:18 $"
__license__ = "BSD"
"""

################
# IMPORTS
################

import os, sys, cgi, re, datetime

################
# CONSTANTS
################
DISTS = {'arch': 'Arch Linux', 'debian': 'Debian', 'fedora': 'Fedora', 'fink': 'Fink', 'freebsd': 'FreeBSD', \
        'macports': 'MacPorts', 'gentoo': 'Gentoo', 'netbsd': 'NetBSD', 'openbsd': 'OpenBSD', 'opensuse': 'OpenSuSE', \
        'slackware': 'Slackware', 'sourcemage': 'Source Mage', 'ubuntu': 'Ubuntu', }

selected_dist = 'debian'        
        
# measure start time
starttime = datetime.datetime.now()

# The CGI 'must-have'
print "Content-type: text/html\n"


# Head of Page
head1 = """
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Whohas</title>
</head>
<body>
<!-- header -->
<h3>Package Search for multiple distributions:</h3>
<p><em>A basic web frontend to <a href="http://www.philippwesche.org/200811/whohas/intro.html">whohas</a> from Philipp Wesche.</em></p>
"""

# footer
foot1 = """
<p><p><p><hr noshade>
<p><em>%s</em>
<p>Powered by <a href="http://www.philippwesche.org/200811/whohas/intro.html">whohas</a>, <a href="http://www.python.org">python</a> 
and <a href="http://httpd.apache.org/">apache</a>, kindly hosted by <a href="http://www.yourdomain.org/">Acme Labs</a>.
"""

# Search form goes here
searchform_start = """
<form id="pkgsearch" name="form_pkgsearch" method="get">
	<div align="right" style="float:right; margin-right:0.01em;">
    <select name="dist" size="%s" multiple style="font-family: arial, helvetica, sans; font-size: 70%%;">
        <option value="None" disabled>Distribution(s):</option>
        %s
    </select>
    </div>
    <input name="q" type="text" value="%s" size="36" maxlength="70" />&nbsp;&nbsp;&nbsp;
    <input name="go" type="Submit" value="Search!" />&nbsp;&nbsp;
</form>
"""

# Result Table Start
rtable_start = """
<p>
<table width="82%%" cellpadding=2 cellspacing=2 style="font-family: arial, helvetica, sans; font-size: 80%%;">
<tr align="center">
<thead>
<th align="left">Dist</th>
<th align="left">Pkg-Name</th>
<th align="left">Version</th>
<th align="left">Pkg-Size</th>
<th align="left">Release /<br>Branch</th>
</thead>
</tr>
"""

# Result Table Row
rtable_row = """<tbody><tr>
    <td>%s</td>
    <td><a href="%s">%s</a></td>
    <td>%s</td>
    <td>%s</td>
    <td>%s</td>
</tr>"""

# Result Table End
rtable_end = """</tbody></table>"""

print head1

# check if a query parameter was sent
whform = cgi.FieldStorage()
f_q = whform.getfirst("q")
f_dist = whform.getlist("dist")


# create distform tmpl
distopt = '<option value="alldists">All</option>'
_dists = DISTS.keys()
_dists.sort()
for _distname in _dists:
    if _distname == selected_dist:
        distopt += """	<option value="%s" selected>%s</option> """ %(_distname, DISTS[_distname])
    else:
        distopt += """	<option value="%s">%s</option> """ %(_distname, DISTS[_distname])
    
if f_q == None:
    print searchform_start %(len(DISTS)+5, distopt, "")
else:
    # spend some cycles on security
    badassregex = re.compile("[^-a-zA-Z0-9]")
    q = badassregex.sub("", f_q)
    if f_dist != None:
        dist = map (lambda ldist: badassregex.sub("", ldist), f_dist)
        search_dists = ",".join(dist)
        if 'alldists' in dist:
            distopt = '<option value="alldists" selected>All</option>'
        else:
            distopt = '<option value="alldists">All</option>'
            
        for _distname in _dists:
            if _distname in dist:
                distopt += """	<option value="%s" selected>%s</option> """ %(_distname, DISTS[_distname])
            else:
                distopt += """	<option value="%s">%s</option> """ %(_distname, DISTS[_distname])
        
    print searchform_start %(len(DISTS)+5, distopt, q)


if f_q != None:
    if search_dists == '' or search_dists == None or search_dists == 'alldists':
        cmd = 'whohas ' + q
    else:
        cmd = "whohas -d %s %s" %(search_dists, q)
        
    searchout = os.popen(cmd)
    results = []


    # Head of Result Table
    print rtable_start

    while 1:
        resultline = searchout.readline()
        if resultline == "":
            break
        #resultrow = re.split("\t+", resultline, )
        #results.append(resultrow)
        dist = resultline[:12].strip()
        pkgname = resultline[12:51].strip()
        pkgver = resultline[51:70].strip()
        pkgsize = resultline[70:74].strip()
        pkgdate = resultline[76:87].strip()
        pkgbranch = resultline[86:97].strip()
        pkgurl = resultline[98:].strip()
        print rtable_row %(dist, pkgurl, pkgname, pkgver, pkgsize, pkgbranch)
        #print " dist: %s\n pkgname: %s\n pkgver: %s\n pkgsize: %s\n branch: %s\n div2: %s\n pkgurl: %s" %(dist, pkgname, pkgver, pkgsize, branch, div2, pkgurl)
            
    print rtable_end    
    searchout.close()

tdelta = datetime.datetime.now() - starttime
tdelta_str = """Search took %ss %sms.""" %(tdelta.seconds, tdelta.microseconds/1000)
print foot1 %(tdelta_str,)
    
print "</div></body></html>\n"

# EOF
